;SYSTEMTIME address is past in eax
;JulianDay address is past in edx

JulianDaytoCalendar PROC
	LOCAL	content[108]:BYTE
	LOCAL	dwMonthYear:DWORD

	push	eax

	fsave	content

;################################################################################
;#				JD=JulianDay+0.5				#
;################################################################################
	fld	REAL10 PTR[edx]						;st=JulianDay
	fadd	Half							;st=JD=JulianDay+0.5
;================================================================================

;################################################################################
;#				z=floor(JD)					#
;################################################################################
	fld	st							;st=JD,st(1)=JD

	INVOKE	FPUFloor						;st=z=floor(JD),st(1)=JD

;================================================================================

;################################################################################
;#				f=JD-z						#
;################################################################################
	fsub	st(1),st						;st=z,st(1)=f=JD-z
;================================================================================

;################################################################################
;#	If z<2299161.0 Then a=z Else alpha=floor((z-1867216.25)/36524.25)	#
;#			a=z+1+alpha-floor(alpha/4)				#
;################################################################################
	fld	TwentyTwoNinetyNineOneSixtyOne				;st=2299161.0,st(1)=z,st(2)=f
	fcomp	st(1)							;st=z,st(1)=f
	fstsw	ax							;retrieve exception flags from FPU
	fwait
	sahf								;transfer to the CPU flags
	ja	JulianDaytoCalendar00000

	fld	st							;st=z,st(1)=z,st(2)=f
	fsub	EightteenSixtySevenTwoSixteen_Quarter			;st=z-1867216.25,st(1)=z,st(2)=f
	fdiv	ThirtySixFiveTwentyFour_Quarter				;st=(z-1867216.25)/36524.25,st(1)=z,st(2)=f

	INVOKE	FPUFix							;st=alpha=floor((z-1867216.25)/36524.25),st(1)=z,st(2)=f

	fld	st							;st=alpha,st(1)=alpha,st(2)=z,st(3)=f
	fdiv	Four							;st=alpha/4,st(1)=alpha,st(2)=z,st(3)=f

	INVOKE	FPUFix							;st=floor(alpha/4),st(1)=alpha,st(2)=z,st(3)=f

	fsub								;st=alpha-floor(alpha/4),st(1)=z,st(2)=f
	fadd								;st=z+alpha-floor(alpha/4),st(1)=f
	fld1								;st=1,st(1)=z+alpha-floor(alpha/4),st(2)=f
	fadd								;st=a=z+1+alpha-floor(alpha/4),st(1)=f
;================================================================================

;################################################################################
;#				b=a+1524					#
;################################################################################

JulianDaytoCalendar00000:

	fadd	FifteenTwentyFour					;st=b=a+1524,st(1)=f
;================================================================================

;################################################################################
;#			c=floor((b-122.1)/365.25)				#
;################################################################################
	fld	OneTwentyTwo_Onetenth					;st=122.1,st(1)=b,st(2)=f
	fsubr	st,st(1)						;st=b-122.1,st(1)=b,st(2)=f
	fdiv	ThreeSixtyFive_Quarter					;st=(b-122.1)/365.25,st(1)=b,st(2)=f

	INVOKE	FPUFloor						;st=c=floor((b-122.1)/365.25),st(1)=b,st(2)=f

;================================================================================

;################################################################################
;#			d=floor(365.25*c)					#
;################################################################################
	fld	ThreeSixtyFive_Quarter					;st=365.25,st(1)=c,st(2)=b,st(3)=f
	fmul	st,st(1)						;st=365.25*c,st(1)=c,st(2)=b,st(3)=f

	INVOKE	FPUFloor						;st=d=floor(365.25*c),st(1)=c,st(2)=b,st(3)=f

;================================================================================

;################################################################################
;#			e=floor((b-d)/30.6001)					#
;################################################################################
	fld	st							;st=d,st(1)=d,st(2)=c,st(3)=b,st(4)=f
	fsubr	st,st(3)						;st=b-d,st(1)=d,st(2)=c,st(3)=b,st(4)=f
	fdiv	Thirty_Sixtenth						;st=(b-d)/30.6001,st(1)=d,st(2)=c,st(3)=b,st(4)=f

	INVOKE	FPUFloor						;st=e=floor((b-d)/30.6001),st(1)=d,st(2)=c,st(3)=b,st(4)=f

;================================================================================

;################################################################################
;#			Day=b-d-floor(30.6001*e)+f				#
;################################################################################
	fld	Thirty_Sixtenth						;st=30.6001,st(1)=e,st(2)=d,st(3)=c,st(4)=b,st(5)=f
	fmul	st,st(1)						;st=30.6001*e,st(1)=e,st(2)=d,st(3)=c,st(4)=b,st(5)=f

	INVOKE	FPUFloor						;st=floor(30.6001*e),st(1)=e,st(2)=d,st(3)=c,st(4)=b,st(5)=f

	fsubr	st,st(4)						;st=b-floor(30.6001*e),st(1)=e,st(2)=d,st(3)=c,st(4)=b,st(5)=f
	fsub	st,st(2)						;st=b-d-floor(30.6001*e),st(1)=e,st(2)=d,st(3)=c,st(4)=b,st(5)=f
	fadd	st,st(5)						;st=Day=b-d-floor(30.6001*e)+f,st(1)=e,st(2)=d,st(3)=c,st(4)=b,st(5)=f
;================================================================================
	INVOKE	FPUFix

	pop	edx

	fistp	(SYSTEMTIME PTR[edx]).wDay				;st=e,st(1)=d,st(2)=c,st(3)=b,st(4)=f

;################################################################################
;#			If e<14 Then Month=e-1 Else Month=e-13			#
;################################################################################

	fistp	dwMonthYear						;st=d,st(1)=c,st(2)=b,st(3)=f
	fwait

	mov	eax,dwMonthYear
	dec	eax
	cmp	al,13
	jb	JulianDaytoCalendar00001

	sub	eax,12
;================================================================================

JulianDaytoCalendar00001:

	mov	(SYSTEMTIME PTR[edx]).wMonth,ax

;################################################################################
;#			If Month>2 Then Year=c-4716 Else Year=c-4715		#
;################################################################################
	fstp	st							;st=c,st(1)=b,st(2)=f
	fistp	dwMonthYear						;st=b,st(1)=f
	fwait

	mov	ecx,dwMonthYear
	sub	ecx,4715
	cmp	al,3
	jb	JulianDaytoCalendar00002

	dec	ecx
;================================================================================

JulianDaytoCalendar00002:

	mov	(SYSTEMTIME PTR[edx]).wYear,cx

	frstor	content

	ret

JulianDaytoCalendar ENDP