JulianMoonPhase PROC
	LOCAL	content[108]:BYTE
	LOCAL	dwSec:DWORD

	fsave	content

;################################################################################
;#				Date within epoch				#
;#				Day=JulianDay-epoch				#
;################################################################################
	fld	JulianDay					;st=JulianDay
	fsub	epoch						;st=Day=JulianDay-epoch
;================================================================================

;################################################################################
;#			Mean anomaly of the Sun					#
;#			N=fixangle((360/365.2422)*Day)				#
;################################################################################
	fld	ThreeSixty					;st=360.0,st(1)=Day
	fdiv	ThreeSixtyFive_TwentyFourhundredths		;st=360.0/365.2422,st(1)=Day
	fmul	st,st(1)					;st=(360.0/365.2422)*Day,st(1)=Day

	INVOKE	FPUFixAngle					;st=N=fixangle((360.0/365.2422)*Day),st(1)=Day
;================================================================================

;################################################################################
;#		Convert from perigee co-ordinates to epoch 1980.0		#
;#			M=fixangle(N+elonge-elongp)				#
;################################################################################
	fadd	elonge						;st=N+elonge,st(1)=Day
	fsub	elongp						;st=N+elonge-elongp,st(1)=Day

	INVOKE	FPUFixAngle					;st=M=fixangle(N+elonge-elongp),st(1)=Day
;================================================================================

;################################################################################
;#			Solve equation of Kepler				#
;################################################################################
	INVOKE	FPUDegtoRad					;st=degtorad(M),st(1)=Day

	INVOKE	FPUKepler					;st=Ec,st(1)=eccent,st(2)=degtorad(M),st(3)=Day
;================================================================================

;################################################################################
;#		Ec=sqrt((1+eccent)/(1-eccent))*tan(Ec/2)			#
;################################################################################
	fld1							;st=1.0,st(1)=Ec,st(2)=eccent,st(3)=degtorad(M),st(4)=Day
	fld	st						;st=1.0,st(1)=1.0,st(2)=Ec,st(3)=eccent,st(4)=degtorad(M),st(5)=Day
	fld	st						;st=1.0,st(1)=1.0,st(2)=1.0,st(3)=Ec,st(4)=eccent,st(5)=degtorad(M),st(6)=Day
	fadd	st,st						;st=2.0,st(1)=1.0,st(2)=1.0,st(3)=Ec,st(4)=eccent,st(5)=degtorad(M),st(6)=Day
	fdivp	st(3),st					;st=1.0,st(1)=1.0,st(2)=Ec/2.0,st(3)=eccent,st(4)=degtorad(M),st(5)=Day
	fsub	st,st(3)					;st=1.0-eccent,st(1)=1.0,st(2)=Ec/2.0,st(3)=eccent,st(4)=degtorad(M),st(5)=Day
	fxch							;st=1.0,st(1)=1.0-eccent,st(2)=Ec/2.0,st(3)=eccent,st(4)=degtorad(M),st(5)=Day
	faddp	st(3),st					;st=1.0-eccent,st(1)=Ec/2.0,st(2)=1.0+eccent,st(3)=degtorad(M),st(4)=Day
	fdivp	st(2),st					;st=Ec/2.0,st(1)=(1.0+eccent)/(1.0-eccent),st(2)=degtorad(M),st(3)=Day
	fsincos
	fdiv							;st=tan(Ec/2.0),st(1)=(1.0+eccent)/(1.0-eccent),st(2)=degtorad(M),st(3)=Day
	fxch							;st=(1.0+eccent)/(1.0-eccent),st(1)=tan(Ec/2.0),st(2)=degtorad(M),st(3)=Day
	fsqrt							;st=sqrt((1.0+eccent)/(1.0-eccent)),st(1)=tan(Ec/2.0),st(2)=degtorad(M),st(3)=Day
	fmul							;st=Ec=sqrt((1.0+eccent)/(1.0-eccent))*tan(Ec/2.0),st(1)=degtorad(M),st(2)=Day
;================================================================================

;################################################################################
;#				True anomaly					#
;#				Ec=2*todeg(atan(Ec))				#
;################################################################################
	fld1							;st=1.0,st(1)=Ec,st(2)=degtorad(M),st(3)=Day
	fpatan							;st=arctan(Ec),st(1)=degtorad(M),st(2)=Day

	INVOKE	FPURadtoDeg					;st=radtodeg(arctan(Ec)),st(1)=degtorad(M),st(2)=Day

	fadd	st,st						;st=Ec=2.0*(radtodeg(arctan(Ec))),st(1)=degtorad(M),st(2)=Day
;================================================================================

;################################################################################
;#			Sun's geocentric ecliptic longitude			#
;#			Lambdasun=fixangle(Ec+elongp)				#
;################################################################################
	fld	elongp						;st=elongp,st(1)=Ec=,st(2)=degtorad(M),st(3)=Day
	fadd	st,st(1)					;st=Ec+elongp,st(1)=Ec,st(2)=degtorad(M),st(3)=Day

	INVOKE	FPUFixAngle					;st=Lambdasun=fixangle(Ec+elongp),st(1)=Ec,st(2)=degtorad(M),st(3)=Day
;================================================================================

;################################################################################
;#			Orbital distance factor					#
;#		F=((1+eccent*cos(torad(Ec)))/(1-eccent*eccent))			#
;################################################################################
	fxch							;st=Ec,st(1)=Lambdasun,st(2)=degtorad(M),st(3)=Day

	INVOKE	FPUDegtoRad					;st=degtorad(Ec),st(1)=Lambdasun,st(2)=degtorad(M),st(3)=Day

	fcos							;st=cos(degtorad(Ec)),st(1)=Lambdasun,st(2)=degtorad(M),st(3)=Day
	fld	eccent						;st=eccent,st(1)=cos(degtorad(Ec)),st(2)=Lambdasun,st(3)=degtorad(M),st(4)=Day
	fld	st						;st=eccent,st(1)=eccent,st(2)=cos(degtorad(Ec)),st(3)=Lambdasun,st(4)=degtorad(M),st(5)=Day
	fmul	st(2),st					;st=eccent,st(1)=eccent,st(2)=eccent*(cos(degtorad(Ec))),st(3)=Lambdasun,st(4)=degtorad(M),st(5)=Day
	fmul							;st=eccent*eccent,st(1)=eccent*(cos(degtorad(Ec))),st(2)=Lambdasun,st(3)=degtorad(M),st(4)=Day
	fld1							;st=1.0,st(1)=eccent*eccent,st(2)=eccent*(cos(degtorad(Ec))),st(3)=Lambdasun,st(4)=degtorad(M),st(5)=Day
	fadd	st(2),st					;st=1.0,st(1)=eccent*eccent,st(2)=1.0+eccent*(cos(degtorad(Ec))),st(3)=Lambdasun,st(4)=degtorad(M),st(5)=Day
	fsubr							;st=1.0-eccent*eccent,st(1)=1.0+eccent*(cos(degtorad(Ec))),st(2)=Lambdasun,st(3)=degtorad(M),st(4)=Day
	fdiv							;st=F=(1.0+eccent*(cos(degtorad(Ec))))/(1.0-eccent*eccent),st(1)=Lambdasun,st(2)=degtorad(M),st(3)=Day
;================================================================================

;################################################################################
;#				Distance to Sun in km				#
;#				SunDist=sunsmax/F				#
;################################################################################
	fld	sunsmax						;st=sunsmax,st(1)=F,st(2)=Lambdasun,st(3)=degtorad(M),st(4)=Day
	fdiv	st,st(1)					;st=SunDist=sunsmax/F,st(1)=F,st(2)=Lambdasun,st(3)=degtorad(M),st(4)=Day
;================================================================================

;################################################################################
;#			Sun's angular size in degrees				#
;#				SunAng=F*sunangsiz				#
;################################################################################
	fld	sunangsiz					;st=sunsangsiz,st(1)=SunDist,st(2)=F,st(3)=Lambdasun,st(4)=degtorad(M),st(5)=Day
	fmulp	st(2),st					;st=SunDist,st(1)=SunAng=F*sunangsiz,st(2)=Lambdasun,st(3)=degtorad(M),st(4)=Day
	fdiv	MilesperKm
	fstp	SunDist						;st=SunAng,st(1)=Lambdasun,st(2)=degtorad(M),st(3)=Day
	fstp	SunAngDia					;st=Lambdasun,st(1)=degtorad(M),st(2)=Day
;================================================================================

;################################################################################
;#				Moon's mean longitude				#
;#			ml=fixangle(13.1763966*Day+mmlong)			#
;################################################################################
	fld	Thirteen_Seventeenhundredths			;st=13.1763966,st(1)=Lambdasun,st(2)=degtorad(M),st(3)=Day
	fmul	st,st(3)					;st=13.1763966*Day,st(1)=Lambdasun,st(2)=degtorad(M),st(3)=Day
	fadd	mmlong						;st=13.1763966*Day+mmlong,st(1)=Lambdasun,st(2)=degtorad(M),st(3)=Day

	INVOKE	FPUFixAngle					;st=ml=fixangle(13.1763966*Day+mmlong),st(1)=Lambdasun,st(2)=degtorad(M),st(3)=Day
;================================================================================

;################################################################################
;#				Moon's mean anomaly				#
;#			MM=fixangle(ml-0.1114041*Day-mmlongp)			#
;################################################################################
	fxch	st(3)						;st=Day,st(1)=Lambdasun,st(2)degtorad(M),st(3)=ml
	fmul	Elevenhundredths				;st=0.1114041*Day,st(1)=Lambdasun,st(2)degtorad(M),st(3)=ml
	fsubr	st,st(3)					;st=ml-0.1114041*Day,st(1)=Lambdasun,st(2)degtorad(M),st(3)=ml
	fsub	mmlongp						;st=ml-0.1114041*Day-mmlongp,st(1)=Lambdasun,st(2)degtorad(M),st(3)=ml

	INVOKE	FPUFixAngle					;st=MM=fixangle(ml-0.1114041*Day-mmlongp),st(1)=Lambdasun,st(2)degtorad(M),st(3)=ml
;================================================================================

;################################################################################
;#				Evection					#
;#		Ev=1.2739*sin(torad(2*(ml-Lambdasun)-MM))			#
;################################################################################
	fld	st(3)						;st=ml,st(1)=MM,st(2)=Lambdasun,st(3)=degtorad(M),st(4)=ml
	fsub	st,st(2)					;st=ml-Lambdasun,st(1)=MM,st(2)=Lambdasun,st(3)=degtorad(M),st(4)=ml
	fadd	st,st						;st=2.0*(ml-Lambdasun),st(1)=MM,st(2)=Lambdasun,st(3)=degtorad(M),st(4)=ml
	fsub	st,st(1)					;st=2.0*(ml-Lambdasun)-MM,st(1)=MM,st(2)=Lambdasun,st(3)=degtorad(M),st(4)=ml

	INVOKE	FPUDegtoRad					;st=degtorad(2.0*(ml-Lambdasun)-MM),st(1)=MM,st(2)=Lambdasun,st(3)=degtorad(M),st(4)=ml

	fsin							;st=sin(degtorad(2.0*(ml-Lambdasun)-MM)),st(1)=MM,st(2)=Lambdasun,st(3)=degtorad(M),st(4)=ml
	fmul	One_Twotenths					;st=Ev=1.2739*sin(degtorad(2.0*(ml-Lambdasun)-MM)),st(1)=MM,st(2)=Lambdasun,st(3)=degtorad(M),st(4)=ml
;================================================================================

;################################################################################
;#				Annual equation					#
;#				Ae=0.1858*sin(torad(M))				#
;################################################################################
	fxch	st(3)						;st=degtorad(M),st(1)=MM,st(2)=Lambdasun,st(3)=Ev,st(4)=ml
	fsin							;st=sin(degtorad(M))st(1)=MM,st(2)=Lambdasun,st(3)=Ev,st(4)=ml
	fld	st						;st=sin(degtorad(M)),st(1)=sin(degtorad(M)),st(2)=MM,st(3)=Lambdasun,st(4)=Ev,st(5)=ml
	fmul	Eightteenhundredths				;st=Ae=0.1858*sin(degtorad(M)),st(1)=sin(degtorad(M)),st(2)=MM,st(3)=Lambdasun,st(4)=Ev,st(5)=ml
;================================================================================

;################################################################################
;#				Correction term					#
;#				A3=0.37*sin(torad(M))				#
;################################################################################
	fxch							;st=sin(degtorad(M)),st(1)=Ae,st(2)=MM,st(3)=Lambdasun,st(4)=Ev,st(5)=ml
	fmul	ThirtySevenhundredths				;st=A3=0.37*sin(degtorad(M)),st(1)=Ae,st(2)=MM,st(3)=Lambdasun,st(4)=Ev,st(5)=ml
;================================================================================

;################################################################################
;#				Corrected anomaly				#
;#				MmP=MM+Ev-Ae-A3					#
;################################################################################
	fsubr	st,st(4)					;st=Ev-A3,st(1)=Ae,st(2)=MM,st(3)=Lambdasun,st(4)=Ev,st(5)=ml
	fsub	st,st(1)					;st=Ev-Ae-A3,st(1)=Ae,st(2)=MM,st(3)=Lambdasun,st(4)=Ev,st(5)=ml
	faddp	st(2),st					;st=Ae,st(1)=MmP=MM+Ev-Ae-A3,st(2)=Lambdasun,st(3)=Ev,st(4)=ml
;================================================================================

;################################################################################
;#		Correction for the equation of the centre			#
;#			mEc=6.2886*sin(torad(MmP))				#
;################################################################################
	fld	st(1)						;st=MmP,st(1)=Ae,st(2)=MmP,st(3)=Lambdasun,st(4)=Ev,st(5)=ml

	INVOKE	FPUDegtoRad					;st=degtorad(MmP),st(1)=Ae,st(2)=MmP,st(3)=Lambdasun,st(4)=Ev,st(5)=ml

	fsin							;st=sin(degtorad(MmP)),st(1)=Ae,st(2)=MmP,st(3)=Lambdasun,st(4)=Ev,st(5)=ml
	fmul	Six_TwentyEighthundredths			;st=mEc=6.2886*sin(degtorad(MmP)),st(1)=Ae,st(2)=MmP,st(3)=Lambdasun,st(4)=Ev,st(5)=ml
;================================================================================

;################################################################################
;#			Another correction term					#
;#			A4=0.214*sin(torad(2*MmP))				#
;################################################################################
	fld	st(2)						;st=MmP,st(1)=mEc,st(2)=Ae,st(3)=MmP,st(4)=Lambdasun,st(5)=Ev,st(6)=ml
	fadd	st,st						;st=2.0*MmP,st(1)=mEc,st(2)=Ae,st(3)=MmP,st(4)=Lambdasun,st(5)=Ev,st(6)=ml

	INVOKE	FPUDegtoRad					;st=degtorad(2.0*MmP),st(1)=mEc,st(2)=Ae,st(3)=MmP,st(4)=Lambdasun,st(5)=Ev,st(6)=ml

	fsin							;st=sin(degtorad(2.0*MmP)),st(1)=mEc,st(2)=Ae,st(3)=MmP,st(4)=Lambdasun,st(5)=Ev,st(6)=ml
	fmul	TwentyOnehundredths				;st=A4=0.214*sin(degtorad(2.0*MmP)),st(1)=mEc,st(2)=Ae,st(3)=MmP,st(4)=Lambdasun,st(5)=Ev,st(6)=ml
;================================================================================

;################################################################################
;#				Corrected longitude				#
;#				lP=ml+Ev+mEc-Ae+A4				#
;################################################################################
	faddp	st(5),st					;st=mEc,st(1)=Ae,st(2)=MmP,st(3)=Lambdasun,st(4)=Ev+A4,st(5)=ml
	fadd	st(4),st					;st=mEc,st(1)=Ae,st(2)=MmP,st(3)=Lambdasun,st(4)=Ev+mEc+A4,st(5)=ml
	fxch	st(4)						;st=Ev+mEc+A4,st(1)=Ae,st(2)=MmP,st(3)=Lambdasun,st(4)=mEc,st(5)=ml
	fsubr							;st=Ev+mEc-Ae+A4,st(1)=MmP,st(2)=Lambdasun,st(3)=mEc,st(4)=ml
	faddp	st(4),st					;st=MmP,st(1)=Lambdasun,st(2)=mEc,st(3)=lP=ml+Ev+mEc-Ae+A4
;================================================================================

;################################################################################
;#				Variation					#
;#			V=0.6583*sin(torad(2*(lP-Lambdasun)))			#
;################################################################################
	fld	st(3)						;st=lP,st(1)=MmP,st(2)=Lambdasun,st(3)=mEc,st(4)=lP
	fsub	st,st(2)					;st=lP-Lambdasun,st(1)=MmP,st(2)=Lambdasun,st(3)=mEc,st(4)=lP
	fadd	st,st						;st=2*(lP-Lambdasun),st(1)=MmP,st(2)=Lambdasun,st(3)=mEc,st(4)=lP

	INVOKE	FPUDegtoRad					;st=degtorad(2*(lP-Lambdasun)),st(1)=MmP,st(2)=Lambdasun,st(3)=mEc,st(4)=lP

	fsin							;st=sin(degtorad(2*(lP-Lambdasun))),st(1)=MmP,st(2)=Lambdasun,st(3)=mEc,st(4)=lP
	fmul	SixtyFivehundredths				;st=V=0.6583*sin(degtorad(2*(lP-Lambdasun))),st(1)=MmP,st(2)=Lambdasun,st(3)=mEc,st(4)=lP
;================================================================================

;################################################################################
;#				True longitude					#
;#				lPP=lP+V					#
;################################################################################
	faddp	st(4),st					;st=MmP,st(1)=Lambdasun,st(2)=mEc,st(3)=lPP=lP+V
;================================================================================

;################################################################################
;#			Age of the Moon in degrees				#
;#			MoonAge=lPP-Lambdasun					#
;################################################################################
	fxch	st(3)						;st=lPP,st(1)=Lambdasun,st(2)=mEc,st(3)=MmP
	fsubr							;st=MoonAge=lPP-Lambdasun,st(1)=mEc,st(2)=MmP
;================================================================================

;################################################################################
;#				Phase of the Moon				#
;#			MoonPhase=(1-cos(torad(MoonAge)))/2			#
;################################################################################
	fld	st						;st=MoonAge,st(1)=MoonAge,st(2)=mEc,st(3)=MmP

	INVOKE	FPUDegtoRad					;st=degtorad(MoonAge),st(1)=MoonAge,st(2)=mEc,st(3)=MmP

	fcos							;st=cos(degtorad(MoonAge)),st(1)=MoonAge,st(2)=mEc,st(3)=MmP
	fld1							;st=1.0,st(1)=cos(degtorad(MoonAge)),st(2)=MoonAge,st(3)=mEc,st(4)=MmP
	fsubr							;st=1.0-cos(degtorad(MoonAge)),st(1)=MoonAge,st(2)=mEc,st(3)=MmP
	fld1							;st=1.0,st(1)=1.0-cos(degtorad(MoonAge)),st(2)=MoonAge,st(3)=mEc,st(4)=MmP
	fadd	st,st						;st=2.0,st(1)=1.0-cos(degtorad(MoonAge)),st(2)=MoonAge,st(3)=mEc,st(4)=MmP
	fdiv							;st=MoonPhase=(1.0-cos(degtorad(MoonAge)))/2.0,st(1)=MoonAge,st(2)=mEc,st(3)=MmP
	fstp	MoonPhase					;st=MoonAge,st(1)=mEc,st(2)=MmP
;================================================================================

;################################################################################
;#		Calculate distance of moon from the centre of the Earth		#
;#		MoonDist=(msmax*(1-mecc*mecc))/(1+mecc*cos(torad(MmP + mEc)))	#
;################################################################################
	fxch	st(2)						;st=MmP,st(1)=mEc,st(2)=MoonAge
	fadd							;st=MmP+mEc,st(1)=MoonAge

	INVOKE	FPUDegtoRad					;st=degtorad(MmP+mEc),st(1)=MoonAge

	fcos							;st=cos(degtorad(MmP+mEc)),st(1)=MoonAge
	fld	mecc						;st=mecc,st(1)=cos(degtorad(MmP+mEc)),st(2)=MoonAge
	fmul	st(1),st					;st=mecc,st(1)=mecc*cos(degtorad(MmP+mEc)),st(2)=MoonAge
	fmul	st,st						;st=mecc*mecc,st(1)=mecc*cos(degtorad(MmP+mEc)),st(2)=MoonAge
	fld1							;st=1.0,st(1)=mecc*mecc,st(2)=mecc*cos(degtorad(MmP+mEc)),st(3)=MoonAge
	fadd	st(2),st					;st=1.0,st(1)=mecc*mecc,st(2)=1.0+mecc*cos(degtorad(MmP+mEc)),st(3)=MoonAge
	fsubr							;st=1.0-mecc*mecc,st(1)=1.0+mecc*cos(degtorad(MmP+mEc)),st(2)=MoonAge
	fmul	msmax						;st=msmax*(1.0-mecc*mecc),st(1)=1.0+mecc*cos(degtorad(MmP+mEc)),st(2)=MoonAge
	fdivr							;st=MoonDist=(msmax*(1.0-mecc*mecc))/(1.0+mecc*cos(degtorad(MmP+mEc))),st(1)=MoonAge
	fld	st
	fdiv	MilesperKm
	fstp	MoonDist					;st=MoonDist,st(1)=MoonAge
;================================================================================

;################################################################################
;#			Calculate Moon's angular diameter			#
;#			MoonDFrac=MoonDist/msmax				#
;#			MoonAng=mangsiz/MoonDFrac				#
;################################################################################
	fdiv	msmax						;st=MoonDFrac=MoonDist/msmax,st(1)=MoonAge
	fld	mangsiz						;st=mangsiz,st(1)=MoonDFrac,st(2)=MoonAge
	fdivr							;st=MoonAng=mangsiz/MoonDFrac,st(1)=MoonAge
	fstp	MoonAngDia					;st=MoonAge
;================================================================================

	INVOKE	FPUFixAngle					;st=fixangle(MoonAge)

	fdiv	ThreeSixty					;st=fixangle(MoonAge)/360.0

	fld	st
	fstp	Phase						;st=fixangle(MoonAge)/360.0

	fmul	synmonth					;st=synmonth*(fixangle(MoonAge)/360.0)

	fld	st
	fstp	MoonAge						;st=synmonth*(fixangle(MoonAge)/360.0)

	fld	st						;st=MoonAge,st(1)=MoonAge

	INVOKE	FPUFix						;st=MoonAgeDay=fix(MoonAge),st(1)=MoonAge

	fld	st
	fistp	MoonAgeDay					;st=MoonAgeDay,st(1)=MoonAge
	fsub							;st=MoonAge-MoonAgeDay
	fmul	EightySixFourhundred				;st=(MoonAge-MoonAgeDay)*86400.0

	INVOKE	FPURound					;st=round((MoonAge-MoonAgeDay)*86400.0)

	fistp	dwSec

	frstor	content
	fwait

	xor	edx,edx
	mov	eax,dwSec
	mov	ecx,3600
	div	ecx
	mov	MoonAgeHour,ax

	mov	eax,edx
	xor	edx,edx
	mov	ecx,60
	div	ecx
	mov	MoonAgeMin,ax

	mov	MoonAgeSec,dx

	ret

JulianMoonPhase ENDP