;JulianDay address is past in eax
;SYSTEMTIME address is past in edx

SystemTimetoJulianDay PROC
	LOCAL	content[108]:BYTE
	LOCAL	dwYear:DWORD
	LOCAL	dwMonth:DWORD

	push	eax

	fsave	content
	fldz					;st=b

;################################################################################
;#				m=Month+1,y=Year				#
;#				If m<=2 Then m=m+12,y=y-1			#
;################################################################################
	movzx	ecx,(SYSTEMTIME PTR[edx]).wMonth
	inc	ecx
	cmp	ecx,2
	movsx	eax,(SYSTEMTIME PTR[edx]).wYear
	ja	SystemTimetoJulianDay00000

	add	cl,12
	dec	eax
;================================================================================

;################################################################################
;#	If (year<1582) or (year=1582 and Month<9) or (Month=9 and Day<5)	#
;#		Then b=0 Else a=floor(y/100),b=2-a+floor(a/4)			#
;################################################################################

SystemTimetoJulianDay00000:

	cmp	eax,1582
	mov	dwMonth,ecx
	mov	dwYear,eax
	movzx	ecx,(SYSTEMTIME PTR[edx]).wMonth
	jb	SystemTimetoJulianDay00002

	jne	SystemTimetoJulianDay00001

	cmp	ecx,9
	movzx	eax,(SYSTEMTIME PTR[edx]).wDay
	jb	SystemTimetoJulianDay00002

	jne	SystemTimetoJulianDay00001

	cmp	eax,4
	ja	SystemTimetoJulianDay00002

SystemTimetoJulianDay00001:

	fld1					;st=1
	fadd	st,st				;st=2
	fld	st				;st=2,st(1)=2
	fadd	st,st				;st=4,st(1)=2
	fild	dwYear				;st=dwYear,st(1)=4,st(2)=2
	fdiv	Onehundred			;st=dwYear/100.0,st(1)=4,st(2)=2

	INVOKE	FPUFloor			;st=a=floor(dwYear/100.0),st(1)=4,st(2)=2
	
	fld	st				;st=a,st(1)=a,st(2)=4,st(3)=2
	fdiv	st,st(2)			;st=a/4,st(1)=a,st(2)=4,st(3)=2

	INVOKE	FPUFloor			;st=floor(a/4),st(1)=a,st(2)=4,st(3)=2

	fadd	st,st(3)			;st=2+floor(a/4),st(1)=a,st(2)=4,st(3)=2
	fsub	st,st(1)			;st=b=2-a+floor(a/4),st(1)=a,st(2)=4,st(3)=2
;================================================================================

;################################################################################
;#				JulianDay=JD+JDF				#
;#		JD=fix(365.25*(y+4716))+fix(30.6001*(m+1))+Day+b-1524.5		#
;#			JDF=(Sec+60*(Min+60*Hour))/86400			#
;################################################################################

SystemTimetoJulianDay00002:

	fild	(SYSTEMTIME PTR[edx]).wHour		;st=Hour,st(1)=b
	fmul	Sixty					;st=60.0*Hour,st(1)=b
	fiadd	(SYSTEMTIME PTR[edx]).wMinute		;st=Min+(60.0*Hour),st(1)=b
	fmul	Sixty					;st=60.0*(Min+(60.0*Hour)),st(1)=b
	fiadd	(SYSTEMTIME PTR[edx]).wSecond		;st=Sec+(60.0*(Min+(60.0*Hour))),st(1)=b
	fdiv	EightySixFourhundred			;st=JDF=(Sec+(60.0*(Min+(60.0*Hour))))/86400.0,st(1)=b
	fld1						;st=1,st(1)=JDF,st(2)=b
	fiadd	dwMonth					;st=m+1,st(1)=JDF,st(2)=b
	fmul	Thirty_Sixtenth				;st=30.6001*(m+1),st(1)=JDF,st(2)=b

	INVOKE	FPUFix					;st=fix(30.6001*(m+1)),st(1)=JDF,st(2)=b

	fld	FortySevenSixteen			;st=4716.0,st(1)=fix(30.6001*(m+1)),st(2)=JDF,st(3)=b
	fiadd	dwYear					;st=y+4716.0,st(1)=fix(30.6001*(m+1)),st(2)=JDF,st(3)=b
	fmul	ThreeSixtyFive_Quarter			;st=365.25*(y+4716.0),st(1)=fix(30.6001*(m+1)),st(2)=JDF,st(3)=b

	INVOKE	FPUFix					;st=fix(365.25*(y+4716.0)),st(1)=fix(30.6001*(m+1)),st(2)=JDF,st(3)=b

	fadd						;st=fix(365.25*(y+4716.0))+fix(30.6001*(m+1)),st(1)=JDF,st(2)=b
	fiadd	(SYSTEMTIME PTR[edx]).wDay		;st=fix(365.25*(y+4716.0))+fix(30.6001*(m+1))+Day,st(1)=JDF,st(2)=b
	fsub	FifteenTwentyFour_Half			;st=fix(365.25*(y+4716.0))+fix(30.6001*(m+1))+Day-1524.5,st(1)=JDF,st(2)=b
	fadd						;st=fix(365.25*(y+4716.0))+fix(30.6001*(m+1))+Day-1524.5+JDF,st(1)=b
	fadd						;st=JulianDay=JD+JDF=fix(365.25*(y+4716.0))+fix(30.6001*(m+1))+Day+b-1524.5+JDF

	pop	edx

	fstp	REAL10 PTR[edx]
;================================================================================

	frstor	content

	ret

SystemTimetoJulianDay ENDP